__kernel void kernel_id(__global float* output)
{
	uint gid = get_global_id(0);
	uint lid = get_local_id(0);
	output[gid] = (float)gid + (float)lid * 0.01f;

	/* PATTERN 1 - 0 and 1 */
	//output[gid] = (float) ( gid % 2);

	/* PATTERN 2 - first 16 work-items 1 rest 0 */
	//output[gid] = (float) ( gid < 16 ? 1 : 0);
}

__kernel void kernel_gflops(__global float* output){
	float gid = (float) get_global_id(0);
	float lid = (float) get_local_id(0);

	/* 2000 operations per work item */
	for(int i=0; i<1000; i++){
		// MAD 2 operations, 1 cycle, 
		// ~980 gflosp on Tesla M2070
		gid = mad(gid, 0.1f, lid);

		// 2 operations MAD, a*x+b, 1 cycle
		//gid = lid + gid * 0.1f;

		// 2 operations, 2 cycles
		//gid = gid + 0.1f + lid;

		// 1 special operation, slower
		//gid = gid / lid;
	}

	output[get_global_id(0)] = gid;
}
